//+------------------------------------------------------------------+
//|                                                     Kuklovod.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.tradelikeapro.ru"
#property version   "1.2"
#property strict
   
  extern int StartLevel         = 10;
  extern int StopLevel          = 30;
  extern int TakeProfitLevel    = 70;
  extern int StopLossLevel      = 10;
  extern double Lot             = 0.01;
  extern int Slippage           = 5;
  extern int Magic              = 4711;
  extern double StartBalance    = 0;
  extern double MaxBalance      = 0;
  extern bool ShowInfo          = true;
  extern bool USDCAD            = true;
  extern bool USDCHF            = true;
  extern bool USDJPY            = true;
  extern bool EURUSD            = true;
  extern bool GBPUSD            = true;
  extern bool AUDUSD            = true;
  extern bool NZDUSD            = true;
  extern color TextColor        = Yellow;
  extern bool Protect           = true;
  extern int  Prosadka          = 20;
  
  int tp, sl, slip;
  double ind;
  bool USDBuy = false, SellUSD = false, USDSell = false, BuyUSD = false,
       USDSellSl = false, BuyUSDSl = false, USDBuySl = false, SellUSDSl = false,
       USDBuyTp = false, SellUSDTp = false, USDSellTp = false, BuyUSDTp = false;
  bool SignalProtection   = false;
  double BalanceMax, PercentProsadka, usdprosadka;
  double profit, profitall, profitusdcad, profitusdchf, profitusdjpy, profiteurusd, profitgbpusd, profitaudusd, profitnzdusd;
  double allprofit, allloss;
  
//============================+++++++++++++++++++++++++++++++++++++
  
  void init(){
   if (Digits == 3 || Digits == 5){slip = Slippage*10;}
   if (Digits == 2 || Digits == 4){slip = Slippage;}
//----
//----
//----
   if (StartBalance == 0){StartBalance = AccountBalance();}
   if (MaxBalance > AccountBalance()){BalanceMax=MaxBalance;}
       else BalanceMax = AccountBalance();
//---
  
  }
  void deinit(){
    ObjectDel("Com",3);
    Print("MaxBalance = "+DoubleToStr(BalanceMax,2)+" $");
    Print ("StartBalance = "+DoubleToStr(StartBalance,2)+" $");
  }
  void start(){
     Comment("USDCAD = "+DoubleToStr(Count("USDCAD",OP_BUY),0));
     if (Protect){Protection();}
     Profit();
     if (!SignalProtection){Signal();}
     if (ShowInfo){Text();}      
      
  }
//+------------------------------------------------------------------+
   void Profit(){
     profit = 0;
     profitall = 0;
     profitusdcad = 0; profitusdchf = 0; profitusdjpy = 0; profiteurusd = 0; profitgbpusd = 0; profitaudusd = 0; profitnzdusd = 0;
     for (int i = OrdersHistoryTotal()-1; i >= 0; i--){
        if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) == true){
          if (OrderMagicNumber() ==  Magic){
            profit = profit + OrderProfit() + OrderCommission() + OrderSwap();
          }
       }
     }
     for (int i = OrdersTotal()-1; i >= 0; i--){
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == true){
           if (OrderMagicNumber() ==  Magic){
              if (OrderType() == OP_BUY){
                 if (OrderSymbol() == "USDCAD"){profitusdcad = (profitusdcad + (MarketInfo("USDCAD",MODE_BID)-OrderOpenPrice()))/MarketInfo("USDCAD",MODE_POINT);}
                 if (OrderSymbol() == "USDCHF"){profitusdchf = (profitusdchf + (MarketInfo("USDCHF",MODE_BID)-OrderOpenPrice()))/MarketInfo("USDCHF",MODE_POINT);}
                 if (OrderSymbol() == "USDJPY"){profitusdjpy = (profitusdjpy + (MarketInfo("USDJPY",MODE_BID)-OrderOpenPrice()))/MarketInfo("USDJPY",MODE_POINT);}
                 if (OrderSymbol() == "EURUSD"){profiteurusd = (profiteurusd + (MarketInfo("EURUSD",MODE_BID)-OrderOpenPrice()))/MarketInfo("EURUSD",MODE_POINT);}
                 if (OrderSymbol() == "GBPUSD"){profitgbpusd = (profitgbpusd + (MarketInfo("GBPUSD",MODE_BID)-OrderOpenPrice()))/MarketInfo("GBPUSD",MODE_POINT);}
                 if (OrderSymbol() == "AUDUSD"){profitaudusd = (profitaudusd + (MarketInfo("AUDUSD",MODE_BID)-OrderOpenPrice()))/MarketInfo("AUDUSD",MODE_POINT);}
                 if (OrderSymbol() == "NZDUSD"){profitnzdusd = (profitnzdusd + (MarketInfo("NZDUSD",MODE_BID)-OrderOpenPrice()))/MarketInfo("NZDUSD",MODE_POINT);}
              }
              if (OrderType() == OP_SELL){
                 if (OrderSymbol() == "USDCAD"){profitusdcad = (profitusdcad + (OrderOpenPrice()-MarketInfo("USDCAD",MODE_ASK)))/MarketInfo("USDCAD",MODE_POINT);}
                 if (OrderSymbol() == "USDCHF"){profitusdchf = (profitusdchf + (OrderOpenPrice()-MarketInfo("USDCHF",MODE_ASK)))/MarketInfo("USDCHF",MODE_POINT);}
                 if (OrderSymbol() == "USDJPY"){profitusdjpy = (profitusdjpy + (OrderOpenPrice()-MarketInfo("USDJPY",MODE_ASK)))/MarketInfo("USDJPY",MODE_POINT);}
                 if (OrderSymbol() == "EURUSD"){profiteurusd = (profiteurusd + (OrderOpenPrice()-MarketInfo("EURUSD",MODE_ASK)))/MarketInfo("EURUSD",MODE_POINT);}
                 if (OrderSymbol() == "GBPUSD"){profitgbpusd = (profitgbpusd + (OrderOpenPrice()-MarketInfo("GBPUSD",MODE_ASK)))/MarketInfo("GBPUSD",MODE_POINT);}
                 if (OrderSymbol() == "AUDUSD"){profitaudusd = (profitaudusd + (OrderOpenPrice()-MarketInfo("AUDUSD",MODE_ASK)))/MarketInfo("AUDUSD",MODE_POINT);}
                 if (OrderSymbol() == "NZDUSD"){profitnzdusd = (profitnzdusd + (OrderOpenPrice()-MarketInfo("NZDUSD",MODE_ASK)))/MarketInfo("NZDUSD",MODE_POINT);}
              }   
           }
        }
     }
     if (Digits == 3 || Digits == 5){  
        profitall = (profitusdcad + profitusdchf + profitusdjpy + profiteurusd + profitgbpusd + profitaudusd + profitnzdusd)/10;
     } else profitall = profitusdcad + profitusdchf + profitusdjpy + profiteurusd + profitgbpusd + profitaudusd + profitnzdusd;
     if (profitall >= 0){allprofit = profitall;}
         else allprofit = 0;
     if (profitall < 0){allloss = profitall;}
         else allloss = 0;
  }
//+------------------------------------------------------------------+
  void Protection(){
    if(AccountBalance()>BalanceMax){BalanceMax=AccountBalance();}  
    PercentProsadka =((BalanceMax-AccountBalance())*100/BalanceMax);
    usdprosadka = BalanceMax - AccountBalance();
    if(PercentProsadka>Prosadka){SignalProtection=true; ProtectionClose();}
  }
//+------------------------------------------------------------------+
  void Signal(){
     ind = iCustom(NULL,PERIOD_D1,"Kuklovod_USD",7,0);
     //-----
     //if (Hour() == 0){      
        if (ind > StartLevel && ind < StopLevel)  {SellUSD = true; USDBuy = true; OpenUsdbuy(); OpenSellusd();}
           else if (ind < StartLevel || ind > StopLevel){USDBuy = false; SellUSD = false;}
        if (ind < -StartLevel && ind > -StopLevel){USDSell = true; BuyUSD = true; OpenUsdSell(); OpenBuyusd();}
           else if (ind > -StartLevel || ind < -StopLevel){USDSell = false; BuyUSD = false;} 
     //--------------------------------------------+++
        if (ind > StopLossLevel) {USDSellSl = true; BuyUSDSl = true; CloseOrders();}
           else if(ind < StopLossLevel){USDSellSl = false; BuyUSDSl = false;}
        if (ind < -StopLossLevel){USDBuySl = true; SellUSDSl = true; CloseOrders();}
           else if(ind > -StopLossLevel){USDBuySl = false; SellUSDSl = false;}
     //--------------------------------------------+++
        if (ind > TakeProfitLevel) {USDBuyTp = true; SellUSDTp = true; CloseOrders();}
           else if( ind < TakeProfitLevel){USDBuyTp  = false; SellUSDTp = false;}
        if (ind < -TakeProfitLevel){USDSellTp = true; BuyUSDTp = true; CloseOrders();}
           else if(ind > -TakeProfitLevel){USDSellTp = false; BuyUSDTp = false;}
     //}
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
   void OpenUsdbuy(){ 
    int Result[3];
    int Answer;    
     if (USDBuy){
        if (USDCAD){
          while(Count("USDCAD",OP_BUY)==0){
            Result[0] = OrderSend("USDCAD",OP_BUY,Lot,MarketInfo("USDCAD",MODE_ASK),slip,0,0,"USDCAD",Magic,0,Red);
            if (Result[0]<0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
            }
            if (Result[0]>0)break;
          }
        }
        if (USDCHF){
          while(Count("USDCHF",OP_BUY)==0){
            Result[1] = OrderSend("USDCHF",OP_BUY,Lot,MarketInfo("USDCHF",MODE_ASK),slip,0,0,"USDCHF",Magic,0,Red);
            if (Result[1]<0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
            }
            if (Result[1]>0)break;
          }
        }
        if (USDJPY){
          while(Count("USDJPY",OP_BUY)==0){
            Result[2] = OrderSend("USDJPY",OP_BUY,Lot,MarketInfo("USDJPY",MODE_ASK),slip,0,0,"USDJPY",Magic,0,Red);
            if (Result[2] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
            }
            if (Result[2]>0)break;
          }
        }
     }
   }
//---
   void OpenSellusd(){
     int Result[4];
     int Answer;
     if (SellUSD){
       if (EURUSD){
         while(Count("EURUSD",OP_SELL)==0){
           Result[0] = OrderSend("EURUSD",OP_SELL,Lot,MarketInfo("EURUSD",MODE_BID),slip,0,0,"EURUSD",Magic,0,Blue);
           if (Result[0] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[0]>0)break;
         }
       }
       if (GBPUSD){
         while(Count("GBPUSD",OP_SELL)==0){
           Result[1] = OrderSend("GBPUSD",OP_SELL,Lot,MarketInfo("GBPUSD",MODE_BID),slip,0,0,"GBPUSD",Magic,0,Blue);
           if (Result[1] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[1]>0)break;
         }
       }
       if (AUDUSD){
         while(Count("AUDUSD",OP_SELL)==0){
           Result[2] = OrderSend("AUDUSD",OP_SELL,Lot,MarketInfo("AUDUSD",MODE_BID),slip,0,0,"AUDUSD",Magic,0,Blue);
           if (Result[2] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[2]>0)break;
         }
       }
       if (NZDUSD){
         while(Count("NZDUSD",OP_SELL)==0){
           Result[3] = OrderSend("NZDUSD",OP_SELL,Lot,MarketInfo("NZDUSD",MODE_BID),slip,0,0,"NZDUSD",Magic,0,Blue);
           if (Result[3] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[3]>0)break;
         }
       }
     }
   }
//---
   void OpenUsdSell(){
     int Result[3];
     int Answer;
     if (USDSell){
       if (USDCAD){
         while(Count("USDCAD",OP_SELL)==0){                 
           Result[0] = OrderSend("USDCAD",OP_SELL,Lot,MarketInfo("USDCAD",MODE_BID),slip,0,0,"USDCAD",Magic,0,Blue);
           if (Result[0] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[0]>0)break;
         }
       }
       if (USDCHF){
         while(Count("USDCHF",OP_SELL)==0){
           Result[1] = OrderSend("USDCHF",OP_SELL,Lot,MarketInfo("USDCHF",MODE_BID),slip,0,0,"USDCHF",Magic,0,Blue);
           if (Result[1] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[1]>0)break;
         }
       }
       if (USDJPY){
         while(Count("USDJPY",OP_SELL)==0){
           Result[2] = OrderSend("USDJPY",OP_SELL,Lot,MarketInfo("USDJPY",MODE_BID),slip,0,0,"USDJPY",Magic,0,Blue);
           if (Result[2] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[2]>0)break;
         }
       }
    }
   }
//---
   void OpenBuyusd(){
     int Result[4];
     int Answer;
     if (BuyUSD){
       if (EURUSD){
         while(Count("EURUSD",OP_BUY)==0){       
           Result[0] = OrderSend("EURUSD",OP_BUY,Lot,MarketInfo("EURUSD",MODE_ASK),slip,0,0,"EURUSD",Magic,0,Red);
           if (Result[0] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[0]>0)break;
         }
       }
       if (GBPUSD){
         while(Count("GBPUSD",OP_BUY)==0){                   
           Result[1] = OrderSend("GBPUSD",OP_BUY,Lot,MarketInfo("GBPUSD",MODE_ASK),slip,0,0,"GBPUSD",Magic,0,Red);
           if (Result[1] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[1]>0)break;
         }
       }
       if (AUDUSD){
         while(Count("AUDUSD",OP_BUY)==0){
           Result[2] = OrderSend("AUDUSD",OP_BUY,Lot,MarketInfo("AUDUSD",MODE_ASK),slip,0,0,"AUDUSD",Magic,0,Red);
           if (Result[2] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[2]>0)break;
         }
       }
       if (NZDUSD){
         while(Count("NZDUSD",OP_BUY)==0){
           Result[3] = OrderSend("NZDUSD",OP_BUY,Lot,MarketInfo("NZDUSD",MODE_ASK),slip,0,0,"NZDUSD",Magic,0,Red);
           if (Result[3] < 0){
              Answer=ERRORS(GetLastError());
              if (Answer==1)continue;
              if (Answer==2)break;
           }
           if (Result[3]>0)break;
         }
       }
     }
   }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
   int Count(string symbol,int otype){
      int count=0;
      for (int i = OrdersTotal()-1; i>=0; i--){
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if (OrderMagicNumber()==Magic) {
               if (OrderSymbol() == symbol&&OrderType()==otype) count++;

            }
         }
      }
      return(count);
   }
//+------------------------------------------------------------------+
   void CloseOrders(){
      int Answer=0;
      bool Result[14];
      for (int i = OrdersTotal()-1; i>=0; i--){
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
             if (OrderMagicNumber() == Magic){
               if (OrderType()==OP_BUY){
                 if (USDBuySl || USDBuyTp){
                  if (OrderSymbol() == "USDCAD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[0]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDCAD",MODE_BID),slip,Blue);
                      if(!Result[0]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
                  if (OrderSymbol() == "USDCHF"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[1]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDCHF",MODE_BID),slip,Blue);
                      if(!Result[1]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }                  
                  if (OrderSymbol() == "USDJPY"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[2]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDJPY",MODE_BID),slip,Blue);
                      if(!Result[2]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
               }
               if (BuyUSDSl || BuyUSDTp){
                 if (OrderSymbol() == "EURUSD"){
                   int cnt=0;
                   while(cnt<=5){
                     Result[10]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("EURUSD",MODE_BID),slip,Blue);
                     if(!Result[10]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                 }
                 if (OrderSymbol() == "GBPUSD"){
                   int cnt=0;
                   while(cnt<=5){
                     Result[11]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("GBPUSD",MODE_BID),slip,Blue);
                     if(!Result[11]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
                  if (OrderSymbol() == "AUDUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[12]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("AUDUSD",MODE_BID),slip,Blue);
                      if(!Result[12]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
                  if (OrderSymbol() == "NZDUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[13]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("NZDUSD",MODE_BID),slip,Blue);
                      if(!Result[13]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
               }
        //==================================
               if (OrderType()==OP_SELL){
                 if (SellUSDSl || SellUSDTp){
                  if (OrderSymbol() == "EURUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[3]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("EURUSD",MODE_ASK),slip,Blue);
                      if(!Result[3]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
                  if (OrderSymbol() == "GBPUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[4]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("GBPUSD",MODE_ASK),slip,Blue);
                      if(!Result[4]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
                  if (OrderSymbol() == "AUDUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[5]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("AUDUSD",MODE_ASK),slip,Blue);
                      if(!Result[5]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
                  if (OrderSymbol() == "NZDUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[6]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("NZDUSD",MODE_ASK),slip,Blue);
                      if(!Result[6]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
               }
               if (USDSellSl || USDSellTp){
                  if (OrderSymbol() == "USDCAD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[7]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDCAD",MODE_ASK),slip,Blue);
                      if(!Result[7]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
                  if (OrderSymbol() == "USDCHF"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[8]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDCHF",MODE_ASK),slip,Blue);
                      if(!Result[8]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
                  if (OrderSymbol() == "USDJPY"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[9]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDJPY",MODE_ASK),slip,Blue);
                      if(!Result[9]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }
                  }
               }
               }
               }
             }      
         }
      }   
        
   }
//+------------------------------------------------------------------+
   void Text (){ 
  string Text[18];
  string Comments[18]={"Comment_1","Comment_2","Comment_3","Comment_4","Comment_5","Comment_6","Comment_7","Comment_8","Comment_9","Comment_10",
                       "Comment_11","Comment_12","Comment_13","Comment_14","Comment_15","Comment_16","Comment_17","Comment_18"};
    Text[0]  ="  = "+DoubleToStr(StartBalance,2);   
    Text[1]  ="  = "+DoubleToStr(BalanceMax,2);   
    Text[2]  ="  = "+DoubleToStr(AccountBalance(),2);
    Text[3]  ="  = "+DoubleToStr(profit,2)+"$";
    Text[4]  =" = "+DoubleToStr(PercentProsadka,2)+" %"; 
    Text[5]  ="           "+DoubleToStr(usdprosadka,2)+" $ ";
    if (profitall >= 0){Text[6] ="  = "+DoubleToStr(profitall,1);}else Text[6] ="  = "+DoubleToStr(profitall,1);
    Text[7]  ="Lot =  "+DoubleToStr(Lot,2);   
    if (!SignalProtection) {Text[8]  =" ";} else Text[8] =" ";
  
    for(int i=0; i<=12; i++){
       
       if(ObjectFind(Comments[i])==-1){                                 
      
          ObjectCreate (Comments[i],OBJ_LABEL,0,0,0);  }                
          ObjectSet    (Comments[i],OBJPROP_CORNER, 1);                                                                           
          ObjectSet    (Comments[i],OBJPROP_XDISTANCE,20);             
          ObjectSet    (Comments[i],OBJPROP_YDISTANCE,30+i*15);         
         
       ObjectSetText(Comments[i],Text[i],10,"Times New Roman",Yellow);    
    } 
 }
//+------------------------------------------------------------------+
  void ObjectDel(string mask,int znk){//,  
    for(int i=ObjectsTotal()-1;i>=0;i--){  //           
        if (StringSubstr(ObjectName(i),0,znk)==mask){ObjectDelete(ObjectName(i));}
    }  
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
  void ProtectionClose(){
    int Answer=0;
    bool Result[14];
    for (int i = OrdersTotal()-1; i>=0; i--){
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
             if (OrderMagicNumber() == Magic){
               if (OrderType()==OP_BUY){
                  if (OrderSymbol() == "USDCAD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[0]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDCAD",MODE_BID),slip,Blue);
                      if(!Result[0]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                      if (Result[0])break;
                    }continue;
                 }
                 if (OrderSymbol() == "USDCHF"){
                   int cnt=0;
                    while(cnt<=5){
                      Result[1]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDCHF",MODE_BID),slip,Blue);
                      if(!Result[1]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                      if (Result[1])break;
                    }continue;
                 }                  
                 if (OrderSymbol() == "USDJPY"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[2]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDJPY",MODE_BID),slip,Blue);
                      if(!Result[2]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                      if (Result[2])break;
                    }continue;
                 }
                 if (OrderSymbol() == "EURUSD"){
                   int cnt=0;
                   while(cnt<=5){
                     Result[10]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("EURUSD",MODE_BID),slip,Blue);
                     if(!Result[10]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                 }
                 if (OrderSymbol() == "GBPUSD"){
                   int cnt=0;
                   while(cnt<=5){
                     Result[11]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("GBPUSD",MODE_BID),slip,Blue);
                     if(!Result[11]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
                  if (OrderSymbol() == "AUDUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[12]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("AUDUSD",MODE_BID),slip,Blue);
                      if(!Result[12]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
                  if (OrderSymbol() == "NZDUSD"){
                    int cnt=0; 
                    while(cnt<=5){
                      Result[13]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("NZDUSD",MODE_BID),slip,Blue);
                      if(!Result[13]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
               }
       //=========================================
               if (OrderType()==OP_SELL){
                  if (OrderSymbol() == "EURUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[3]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("EURUSD",MODE_ASK),slip,Blue);
                      if(!Result[3]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
                  if (OrderSymbol() == "GBPUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[4]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("GBPUSD",MODE_ASK),slip,Blue);
                      if(!Result[4]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
                  if (OrderSymbol() == "AUDUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[5]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("AUDUSD",MODE_ASK),slip,Blue);
                      if(!Result[5]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
                  if (OrderSymbol() == "NZDUSD"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[6]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("NZDUSD",MODE_ASK),slip,Blue);
                      if(!Result[6]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
                  if (OrderSymbol() == "USDCAD"){
                   int cnt=0;
                    while(cnt<=5){
                      Result[7]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDCAD",MODE_ASK),slip,Blue);
                      if(!Result[7]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
                  if (OrderSymbol() == "USDCHF"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[8]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDCHF",MODE_ASK),slip,Blue);
                      if(!Result[8]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
                  if (OrderSymbol() == "USDJPY"){
                    int cnt=0;
                    while(cnt<=5){
                      Result[9]=OrderClose(OrderTicket(),OrderLots(),MarketInfo("USDJPY",MODE_ASK),slip,Blue);
                      if(!Result[9]){
                        Answer=ERRORS(GetLastError());
                        if (Answer==1)continue; cnt++;
                        if (Answer==2)break;
                      }
                    }continue;
                  }
               }
             }      
         }
      }   
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
   string errors(int error){
     string error_string;
     switch(error){
         case 0:   error_string=" OK";                                      break;
         case 1:   error_string="  ";                    break;
         case 2:   error_string="  ";                            break;
         case 3:   error_string="  ";                  break;
         case 4:   error_string="   ";                   break;
         case 5:   error_string="   ";                 break;
         case 6:   error_string="     ";           break;
         case 7:   error_string="  ";                       break;
         case 8:   error_string="   ";                  break;
         case 9:   error_string="  ";                   break;
         case 64:  error_string="  ";                       break;
         case 65:  error_string="   ";                break;
         case 128: error_string="   ";                  break;
         case 129: error_string="  ";                       break;
         case 130: error_string="  , SL  ";            break;
         case 131: error_string="  ";                      break;
         case 132: error_string="  ";                            break;
         case 133: error_string="  ";                      break;
         case 134: error_string="  ";                    break;
         case 135: error_string="  ";                         break;
         case 136: error_string="  ";                                 break;
         case 137: error_string="  ";                            break;
         case 138: error_string="  ";                              break;
         case 139: error_string="  ";                    break;
         case 140: error_string="   ";                break;
         case 141: error_string="   ";                  break;
         case 145: error_string="     ";            break;
         case 146: error_string="   ";              break;
         case 147: error_string="    ";          break;
         case 148: error_string="   ";           break;
         case 149: error_string="  ";                  break;
         case 150: error_string="   FIFO";                   break;
         default:  error_string="   ";                    break;
     }
     return (error_string);
  }
//+------------------------------------------------------------------+
int ERRORS(int Error) 
{
      switch(Error)
   { //  
   case 0: return(1);
   case 4: Print("  .   ...");
   Sleep(500); //  
   return(1); //   
   case 128:   //    
   return(1);
   case 129: Print(" .   ...");
   return(1); //   
   case 132: Print(" .   ...");
   Sleep(123000); //     .    2     ,       00:00
   return(1); //   
   case 135: Print(" .   ...");
   RefreshRates(); //  
   return(1); //   
   case 136: Print(" .   ...");
   while(RefreshRates()==false) //   
   Sleep(1); //   
   return(1); //   
   case 137: Print(" .   ...");
   Sleep(500); //  
   return(1); //   
   case 138: Print(" .   ...");
   Sleep(1); //   
   return(1); //   
   case 146: Print("  .  ...");
   Sleep(500); //  
   return(1); //   
   case 4107: Print("     .  ...");
   Sleep(50); //  
   return(1); //   
//  
   case 1:
   return(0);
   case 2: Alert(" .   \ .");
   return(2); //   
   case 5: Alert("  .");
   //Work=false; //   
   return(2); //   
   case 64: Alert(" .");
   //Work=false; //   
   return(2); //   
   case 130: Alert(" .");
   return(2); //   
   case 133: Alert(" .");
   return(2); //   
   case 134: Alert("    .");
   return(2); //   
   case 4051: Alert("   .");
   return(2); //   
   case 4108: Alert("  .");
   return(2); //   
   default: Print("  ",Error); //  
   return(2); //   
   }
}
//+------------------------------------------------------------------+